Index: branches/FLEXPART_9.1.3/src/FLEXPART.f90
===================================================================
--- trunk/src/FLEXPART.f90	(revision 14)
+++ branches/FLEXPART_9.1.3/src/FLEXPART.f90	(revision 14)
@@ -49,4 +49,5 @@
   integer :: i,j,ix,jy,inest
   integer :: idummy = -320
+  character(len=256) :: pathfile
 
   ! Generate a large number of random numbers
@@ -60,5 +61,6 @@
   ! Print the GPL License statement
   !*******************************************************
-  print*,'Welcome to FLEXPART Version 9.0'
+  ! print*,'Welcome to FLEXPART Version 9.1 (Build 20121029)'
+  print*,'Welcome to FLEXPART Version 9.1.3 (Build 2013158)'
   print*,'FLEXPART is free software released under the GNU Genera'// &
        'l Public License.'
@@ -67,5 +69,17 @@
   !*******************************************************
 
-  call readpaths
+  select case (iargc())
+  case (1)
+    call getarg(1,pathfile)
+    if (trim(pathfile).eq.'-v') then
+        !write(*,*) 'FLEXPART Version 9.1.3 (Build 2013158)'
+        stop
+    endif  
+  case (0)
+    write(pathfile,'(a11)') './pathnames'
+  end select
+
+  call readpaths(pathfile)
+  print*,length(4)
 
   ! Read the user specifications for the current model run
Index: branches/FLEXPART_9.1.3/src/Makefile.ecmwf
===================================================================
--- branches/FLEXPART_9.1.3/src/Makefile.ecmwf	(revision 14)
+++ branches/FLEXPART_9.1.3/src/Makefile.ecmwf	(revision 14)
@@ -0,0 +1,104 @@
+SHELL = /bin/bash
+MAIN = FLEXPART_GFORTRAN
+#
+
+FC       = gfortran
+#INCPATH  = /usr/local/ecmwf_tools/reloc/include
+#LIBPATH1 = /usr/local/ecmwf_tools/reloc/lib
+#LIBPATH2 = /usr/local/lib
+#FFLAGS   = -O3 -g -fbounds-check -m64 -mcmodel=medium -fconvert=little-endian -frecord-marker=4 -I$(INCPATH)
+FFLAGS   = -O3 -m64 -mcmodel=medium -fconvert=little-endian -frecord-marker=4 -I$(INCPATH)
+#LDFLAGS  = $(FFLAGS) -L$(LIBPATH2) -L$(LIBPATH1) -lgrib_api_f90 -lgrib_api -lm -lopenjpeg
+
+# options for nordre
+INCPATH  = /xnilu_wrk/flex_wrk/bin64/grib_api/include
+LIBPATH1 = /xnilu_wrk/flex_wrk/bin64/grib_api/lib
+LIBPATH2 =   /usr/lib/x86_64-linux-gnu/
+#FFLAGS   =   -O2 -m64 -mcmodel=medium -fconvert=little-endian -frecord-marker=4 -I$(INCPATH)
+LDFLAGS  = $(FFLAGS) -L$(LIBPATH2) -L$(LIBPATH1) -lgrib_api_f90 -lgrib_api -lm -ljasper
+
+#options for Lion
+libs_dir=/Users/ignacio_in_EBCRPA/flexpart/libs/
+INCPATH  = $(libs_dir)/grib_api-1.9.9_dir/include
+LIBPATH1 = $(libs_dir)/grib_api-1.9.9_dir/lib
+LIBPATH2 = $(libs_dir)/jasper_dir/lib
+
+
+
+MODOBJS = \
+par_mod.o               com_mod.o \
+conv_mod.o              hanna_mod.o \
+interpol_mod.o          cmapf_mod.o \
+unc_mod.o               oh_mod.o \
+xmass_mod.o             flux_mod.o \
+point_mod.o             outg_mod.o
+
+OBJECTS = \
+writeheader.o           assignland.o\
+calcpar.o               part0.o \
+caldate.o               partdep.o \
+coordtrafo.o            psih.o \
+raerod.o \
+drydepokernel.o         random.o \
+readavailable.o \
+ew.o                    readcommand.o \
+advance.o               readdepo.o \
+releaseparticles.o      psim.o     \
+FLEXPART.o              readlanduse.o \
+getfields.o             init_domainfill.o\
+interpol_wind.o         readoutgrid.o \
+interpol_all.o          readpaths.o \
+getrb.o                 readreceptors.o \
+getrc.o                 readreleases.o \
+getvdep.o               readspecies.o \
+interpol_misslev.o      readwind.o \
+conccalc.o              richardson.o \
+concoutput.o            scalev.o \
+pbl_profile.o           readOHfield.o\
+juldate.o               timemanager.o \
+interpol_vdep.o         interpol_rain.o \
+verttransform.o         partoutput.o \
+hanna.o                 wetdepokernel.o \
+mean.o                  wetdepo.o \
+hanna_short.o           windalign.o \
+obukhov.o               gridcheck.o \
+hanna1.o                initialize.o \
+                        gridcheck_nests.o \
+readwind_nests.o        calcpar_nests.o \
+verttransform_nests.o   interpol_all_nests.o \
+interpol_wind_nests.o   interpol_misslev_nests.o \
+interpol_vdep_nests.o   interpol_rain_nests.o \
+getvdep_nests.o \
+readageclasses.o        readpartpositions.o \
+calcfluxes.o            fluxoutput.o \
+qvsat.o                 skplin.o \
+convmix.o               calcmatrix.o \
+convect43c.o               redist.o \
+sort2.o                 distance.o \
+centerofmass.o          plumetraj.o \
+openouttraj.o           calcpv.o \
+calcpv_nests.o          distance2.o \
+clustering.o            interpol_wind_short.o \
+interpol_wind_short_nests.o shift_field_0.o \
+shift_field.o           outgrid_init.o \
+openreceptors.o         boundcond_domainfill.o\
+partoutput_short.o      readoutgrid_nest.o \
+outgrid_init_nest.o     writeheader_nest.o \
+concoutput_nest.o       wetdepokernel_nest.o \
+drydepokernel_nest.o    zenithangle.o \
+ohreaction.o            getvdep_nests.o \
+initial_cond_calc.o     initial_cond_output.o \
+dynamic_viscosity.o     get_settling.o
+
+
+$(MAIN): $(MODOBJS) $(OBJECTS)
+	$(FC) *.o -o $(MAIN) $(LDFLAGS)
+
+$(OBJECTS): $(MODOBJS)
+
+%.o: %.f90
+	$(FC) -c $(FFLAGS) $<
+
+clean:
+	rm *.o *.mod
+
Index: branches/FLEXPART_9.1.3/src/Makefile.ecmwf.lion
===================================================================
--- branches/FLEXPART_9.1.3/src/Makefile.ecmwf.lion	(revision 14)
+++ branches/FLEXPART_9.1.3/src/Makefile.ecmwf.lion	(revision 14)
@@ -0,0 +1,104 @@
+SHELL = /bin/bash
+MAIN = FLEXPART_GFORTRAN
+#
+
+FC       = gfortran
+#INCPATH  = /usr/local/ecmwf_tools/reloc/include
+#LIBPATH1 = /usr/local/ecmwf_tools/reloc/lib
+#LIBPATH2 = /usr/local/lib
+#FFLAGS   = -O3 -g -fbounds-check -m64 -mcmodel=medium -fconvert=little-endian -frecord-marker=4 -I$(INCPATH)
+FFLAGS   = -O3 -m64 -mcmodel=medium -fconvert=little-endian -frecord-marker=4 -I$(INCPATH)
+#LDFLAGS  = $(FFLAGS) -L$(LIBPATH2) -L$(LIBPATH1) -lgrib_api_f90 -lgrib_api -lm -lopenjpeg
+
+# options for nordre
+INCPATH  = /xnilu_wrk/flex_wrk/bin64/grib_api/include
+LIBPATH1 = /xnilu_wrk/flex_wrk/bin64/grib_api/lib
+LIBPATH2 =   /usr/lib/x86_64-linux-gnu/
+#FFLAGS   =   -O2 -m64 -mcmodel=medium -fconvert=little-endian -frecord-marker=4 -I$(INCPATH)
+LDFLAGS  = $(FFLAGS) -L$(LIBPATH2) -L$(LIBPATH1) -lgrib_api_f90 -lgrib_api -lm -ljasper
+
+#options for Lion
+libs_dir=/Users/ignacio_in_EBCRPA/flexpart/libs/
+INCPATH  = $(libs_dir)/grib_api-1.9.9_dir/include
+LIBPATH1 = $(libs_dir)/grib_api-1.9.9_dir/lib
+LIBPATH2 = $(libs_dir)/jasper_dir/lib
+
+
+
+MODOBJS = \
+par_mod.o               com_mod.o \
+conv_mod.o              hanna_mod.o \
+interpol_mod.o          cmapf_mod.o \
+unc_mod.o               oh_mod.o \
+xmass_mod.o             flux_mod.o \
+point_mod.o             outg_mod.o
+
+OBJECTS = \
+writeheader.o           assignland.o\
+calcpar.o               part0.o \
+caldate.o               partdep.o \
+coordtrafo.o            psih.o \
+raerod.o \
+drydepokernel.o         random.o \
+readavailable.o \
+ew.o                    readcommand.o \
+advance.o               readdepo.o \
+releaseparticles.o      psim.o     \
+FLEXPART.o              readlanduse.o \
+getfields.o             init_domainfill.o\
+interpol_wind.o         readoutgrid.o \
+interpol_all.o          readpaths.o \
+getrb.o                 readreceptors.o \
+getrc.o                 readreleases.o \
+getvdep.o               readspecies.o \
+interpol_misslev.o      readwind.o \
+conccalc.o              richardson.o \
+concoutput.o            scalev.o \
+pbl_profile.o           readOHfield.o\
+juldate.o               timemanager.o \
+interpol_vdep.o         interpol_rain.o \
+verttransform.o         partoutput.o \
+hanna.o                 wetdepokernel.o \
+mean.o                  wetdepo.o \
+hanna_short.o           windalign.o \
+obukhov.o               gridcheck.o \
+hanna1.o                initialize.o \
+                        gridcheck_nests.o \
+readwind_nests.o        calcpar_nests.o \
+verttransform_nests.o   interpol_all_nests.o \
+interpol_wind_nests.o   interpol_misslev_nests.o \
+interpol_vdep_nests.o   interpol_rain_nests.o \
+getvdep_nests.o \
+readageclasses.o        readpartpositions.o \
+calcfluxes.o            fluxoutput.o \
+qvsat.o                 skplin.o \
+convmix.o               calcmatrix.o \
+convect43c.o               redist.o \
+sort2.o                 distance.o \
+centerofmass.o          plumetraj.o \
+openouttraj.o           calcpv.o \
+calcpv_nests.o          distance2.o \
+clustering.o            interpol_wind_short.o \
+interpol_wind_short_nests.o shift_field_0.o \
+shift_field.o           outgrid_init.o \
+openreceptors.o         boundcond_domainfill.o\
+partoutput_short.o      readoutgrid_nest.o \
+outgrid_init_nest.o     writeheader_nest.o \
+concoutput_nest.o       wetdepokernel_nest.o \
+drydepokernel_nest.o    zenithangle.o \
+ohreaction.o            getvdep_nests.o \
+initial_cond_calc.o     initial_cond_output.o \
+dynamic_viscosity.o     get_settling.o
+
+
+$(MAIN): $(MODOBJS) $(OBJECTS)
+	$(FC) *.o -o $(MAIN) $(LDFLAGS)
+
+$(OBJECTS): $(MODOBJS)
+
+%.o: %.f90
+	$(FC) -c $(FFLAGS) $<
+
+clean:
+	rm *.o *.mod
+
Index: branches/FLEXPART_9.1.3/src/Makefile.gfs
===================================================================
--- branches/FLEXPART_9.1.3/src/Makefile.gfs	(revision 14)
+++ branches/FLEXPART_9.1.3/src/Makefile.gfs	(revision 14)
@@ -0,0 +1,90 @@
+SHELL = /bin/bash
+MAIN = FLEXPART_GFS_GFORTRAN
+#
+
+FC       = gfortran
+INCPATH  = /usr/local/ecmwf_tools/reloc/include
+LIBPATH1 = /usr/local/ecmwf_tools/reloc/lib
+LIBPATH2 = /usr/local/lib
+#FFLAGS   = -O3 -g -fbounds-check -m64 -mcmodel=medium -fconvert=little-endian -frecord-marker=4 -I$(INCPATH)
+FFLAGS   = -O3 -m64 -mcmodel=medium -fconvert=little-endian -frecord-marker=4 -I$(INCPATH)
+LDFLAGS  = $(FFLAGS) -L$(LIBPATH2) -L$(LIBPATH1) -lgrib_api_f90 -lgrib_api -lm -lopenjpeg
+#
+
+MODOBJS = \
+par_mod.o               com_mod.o \
+conv_mod.o              hanna_mod.o \
+interpol_mod.o          cmapf_mod.o \
+unc_mod.o               oh_mod.o \
+xmass_mod.o             flux_mod.o \
+point_mod.o             outg_mod.o
+
+OBJECTS = \
+writeheader.o           assignland.o\
+calcpar_gfs.o           part0.o \
+caldate.o               partdep.o \
+coordtrafo.o            psih.o \
+raerod.o \
+drydepokernel.o         random.o \
+erf.o			readavailable.o \
+ew.o                    readcommand.o \
+advance.o               readdepo.o \
+releaseparticles.o      psim.o     \
+FLEXPART.o              readlanduse.o \
+getfields.o             init_domainfill.o\
+interpol_wind.o         readoutgrid.o \
+interpol_all.o          readpaths.o \
+getrb.o                 readreceptors.o \
+getrc.o                 readreleases.o \
+getvdep.o               readspecies.o \
+interpol_misslev.o      readwind_gfs.o \
+conccalc.o              richardson_gfs.o \
+concoutput.o            scalev.o \
+pbl_profile.o           readOHfield.o\
+juldate.o               timemanager.o \
+interpol_vdep.o         interpol_rain.o \
+verttransform_gfs.o         partoutput.o \
+hanna.o                 wetdepokernel.o \
+mean.o                  wetdepo.o \
+hanna_short.o           windalign.o \
+obukhov_gfs.o           gridcheck_gfs.o \
+hanna1.o                initialize.o \
+                        gridcheck_nests.o \
+readwind_nests.o        calcpar_nests.o \
+verttransform_nests.o   interpol_all_nests.o \
+interpol_wind_nests.o   interpol_misslev_nests.o \
+interpol_vdep_nests.o   interpol_rain_nests.o \
+getvdep_nests.o \
+readageclasses.o        readpartpositions.o \
+calcfluxes.o            fluxoutput.o \
+qvsat.o                 skplin.o \
+convmix_gfs.o               calcmatrix_gfs.o \
+convect43c.o            redist.o \
+sort2.o                 distance.o \
+centerofmass.o          plumetraj.o \
+openouttraj.o           calcpv.o \
+calcpv_nests.o          distance2.o \
+clustering.o            interpol_wind_short.o \
+interpol_wind_short_nests.o shift_field_0.o \
+shift_field.o           outgrid_init.o \
+openreceptors.o         boundcond_domainfill.o\
+partoutput_short.o      readoutgrid_nest.o \
+outgrid_init_nest.o     writeheader_nest.o \
+concoutput_nest.o       wetdepokernel_nest.o \
+drydepokernel_nest.o    zenithangle.o \
+ohreaction.o            getvdep_nests.o \
+initial_cond_calc.o     initial_cond_output.o \
+dynamic_viscosity.o     get_settling.o
+
+
+$(MAIN): $(MODOBJS) $(OBJECTS)
+	$(FC) *.o -o $(MAIN) $(LDFLAGS)
+
+$(OBJECTS): $(MODOBJS)
+
+%.o: %.f90
+	$(FC) -c $(FFLAGS) $<
+
+clean:
+	rm *.o *.mod
+
Index: branches/FLEXPART_9.1.3/src/com_mod.f90
===================================================================
--- trunk/src/com_mod.f90	(revision 14)
+++ branches/FLEXPART_9.1.3/src/com_mod.f90	(revision 14)
@@ -7,5 +7,5 @@
 !        June 1996                                                             *
 !                                                                              *
-!        Last update: 9 August 2000                                            *
+!        Last update:15 August 2013 IP                                         *
 !                                                                              *
 !*******************************************************************************
@@ -139,4 +139,6 @@
   real :: decay(maxspec)
   real :: weta(maxspec),wetb(maxspec)
+! NIK: 31.01.2013- parameters for in-cloud scavening
+  real :: weta_in(maxspec), wetb_in(maxspec), wetc_in(maxspec), wetd_in(maxspec)
   real :: reldiff(maxspec),henry(maxspec),f0(maxspec)
   real :: density(maxspec),dquer(maxspec),dsigma(maxspec)
@@ -172,5 +174,7 @@
 
   ! WET DEPOSITION
-  ! weta, wetb              parameters for determining wet scavenging coefficients
+  ! weta, wetb              parameters for determining below-cloud wet scavenging coefficients
+  ! weta_in, wetb_in       parameters for determining in-cloud wet scavenging coefficients
+  ! wetc_in, wetd_in       parameters for determining in-cloud wet scavenging coefficients
 
   ! GAS DEPOSITION
@@ -331,6 +335,10 @@
   real :: qvh(0:nxmax-1,0:nymax-1,nuvzmax,2)
   real :: pplev(0:nxmax-1,0:nymax-1,nuvzmax,2)
+  !scavenging NIK, PS
   integer(kind=1) :: clouds(0:nxmax-1,0:nymax-1,nzmax,2)
   integer :: cloudsh(0:nxmax-1,0:nymax-1,2)
+      integer icloudbot(0:nxmax-1,0:nymax-1,2)
+      integer icloudthck(0:nxmax-1,0:nymax-1,2)
+
 
   ! uu,vv,ww [m/2]       wind components in x,y and z direction
@@ -346,4 +354,8 @@
   !      rainout  conv/lsp dominated  2/3
   !      washout  conv/lsp dominated  4/5
+! PS 2013
+!c icloudbot (m)        cloud bottom height
+!c icloudthck (m)       cloud thickness     
+
   ! pplev for the GFS version
 
Index: branches/FLEXPART_9.1.3/src/concoutput.f90
===================================================================
--- trunk/src/concoutput.f90	(revision 14)
+++ branches/FLEXPART_9.1.3/src/concoutput.f90	(revision 14)
@@ -158,5 +158,5 @@
         yl=outlat0+real(jy)*dyout
         xl=(xl-xlon0)/dx
-        yl=(yl-ylat0)/dx
+        yl=(yl-ylat0)/dy !v9.1.1 
         iix=max(min(nint(xl),nxmin1),0)
         jjy=max(min(nint(yl),nymin1),0)
Index: branches/FLEXPART_9.1.3/src/erf.f90
===================================================================
--- trunk/src/erf.f90	(revision 14)
+++ branches/FLEXPART_9.1.3/src/erf.f90	(revision 14)
@@ -42,10 +42,10 @@
 
   integer :: j
-  real :: x,tmp,ser,xx,gammln
-  real :: cof(6) = (/ &
+  real(kind=dp) :: x,tmp,ser,xx,gammln
+  real(KIND=dp) :: cof(6) = (/ &
        76.18009173_dp, -86.50532033_dp, 24.01409822_dp, &
        -1.231739516_dp, .120858003e-2_dp, -.536382e-5_dp    /)
-  real :: stp = 2.50662827465_dp
-  real :: half = 0.5_dp, one = 1.0_dp, fpf = 5.5_dp
+  real(KIND=dp) :: stp = 2.50662827465_dp
+  real(KIND=dp) :: half = 0.5_dp, one = 1.0_dp, fpf = 5.5_dp
 
   x=xx-one
@@ -62,7 +62,9 @@
 function gammp(a,x)
 
-  implicit none
-
-  real :: a, x, gln, gamser, gammp, gammcf
+  use par_mod, only: dp
+
+  implicit none
+
+  real(KIND=dp) :: a, x, gln, gamser, gammp, gammcf
 
   if(x .lt. 0. .or. a .le. 0.) then
@@ -81,7 +83,9 @@
 function gammq(a,x)
 
-  implicit none
-
-  real :: a, x, gln, gamser, gammq, gammcf
+  use par_mod, only: dp
+
+  implicit none
+
+  real(KIND=dp) :: a, x, gln, gamser, gammq, gammcf
 
   if(x.lt.0..or.a.le.0.) then
@@ -100,9 +104,11 @@
 subroutine gser(gamser,a,x,gln)
 
+  use par_mod, only: dp
+
   implicit none
 
   integer :: n
-  real :: gamser, a, x, gln, ap, summ, del
-  real, external :: gammln
+  real(KIND=dp) :: gamser, a, x, gln, ap, summ, del
+  real(KIND=dp), external :: gammln
 
   integer,parameter :: itmax=100
@@ -134,9 +140,11 @@
 subroutine gcf(gammcf,a,x,gln)
 
+  use par_mod, only: dp
+
   implicit none
 
   integer :: n
-  real :: gammcf, a, x, gln, gold, a0, a1, b0, b1, fac, an, anf, ana, g
-  real, external :: gammln
+  real(KIND=4) :: gammcf, x, a, gln, gold, a0, a1, b0, b1, fac, an, anf, ana, g
+  real(KIND=dp), external :: gammln
 
   integer,parameter :: itmax=100
@@ -172,8 +180,10 @@
 function erf(x)
 
-  implicit none
-
-  real :: x, erf
-  real, external :: gammp
+  use par_mod, only: dp
+
+  implicit none
+
+  real(KIND=dp) :: x, erf
+  real(KIND=dp), external :: gammp
 
   if(x.lt.0.)then
@@ -186,8 +196,10 @@
 function erfc(x)
 
-  implicit none
-
-  real :: x, erfc
-  real, external :: gammp, gammq
+  use par_mod, only: dp
+
+  implicit none
+
+  real(KIND=dp) :: x, erfc
+  real(KIND=dp), external :: gammp, gammq
 
   if(x.lt.0.)then
@@ -200,7 +212,9 @@
 function erfcc(x)
 
-  implicit none
-
-  real :: x, z, t, erfcc
+  use par_mod, only: dp
+
+  implicit none
+
+  real(KIND=dp) :: x, z, t, erfcc
 
   z=abs(x)
Index: branches/FLEXPART_9.1.3/src/gridcheck.f90
===================================================================
--- trunk/src/gridcheck.f90	(revision 14)
+++ branches/FLEXPART_9.1.3/src/gridcheck.f90	(revision 14)
@@ -98,5 +98,6 @@
 
   integer :: isec1(56),isec2(22+nxmax+nymax)
-  real(kind=4) :: zsec2(60+2*nuvzmax),zsec4(jpunp)
+  !real(kind=4) :: zsec2(60+2*nuvzmax),zsec4(jpunp)
+  real(kind=4) :: zsec2(184),zsec4(jpunp)
   character(len=1) :: opt
 
@@ -466,5 +467,4 @@
     k=nlev_ec+1+numskip+i
     akm(nwz-i+1)=zsec2(j)
-  !   write (*,*) 'ifield:',ifield,k,j,zsec2(10+j)
     bkm(nwz-i+1)=zsec2(k)
   end do
Index: branches/FLEXPART_9.1.3/src/interpol_rain.f90
===================================================================
--- trunk/src/interpol_rain.f90	(revision 14)
+++ branches/FLEXPART_9.1.3/src/interpol_rain.f90	(revision 14)
@@ -20,8 +20,15 @@
 !**********************************************************************
 
-subroutine interpol_rain(yy1,yy2,yy3,nxmax,nymax,nzmax,nx, &
-       ny,memind,xt,yt,level,itime1,itime2,itime,yint1,yint2,yint3)
-  !                          i   i   i    i    i     i   i
-  !i    i    i  i    i     i      i      i     o     o     o
+!subroutine interpol_rain(yy1,yy2,yy3,nxmax,nymax,nzmax,nx, &
+!       ny,memind,xt,yt,level,itime1,itime2,itime,yint1,yint2,yint3)
+!  !                          i   i   i    i    i     i   i
+!  !i    i    i  i    i     i      i      i     o     o     o
+
+      subroutine interpol_rain(yy1,yy2,yy3,iy1,iy2,nxmax,nymax,nzmax,nx, &
+     ny,memind,xt,yt,level,itime1,itime2,itime,yint1,yint2,yint3, &
+     intiy1,intiy2,icmv)
+!                               i   i   i    i    i     i   i 
+!     i    i    i  i    i     i      i      i     o     o     o
+
   !****************************************************************************
   !                                                                           *
@@ -40,5 +47,8 @@
   !                                                                           *
   !     30 August 1996                                                        *
-  !                                                                           *
+  !
+  !*  Petra Seibert, 2011/2012:
+  !*  Add interpolation of cloud bottom and cloud thickness
+  !*  for fix to SE's new wet scavenging scheme  *
   !****************************************************************************
   !                                                                           *
@@ -70,10 +80,15 @@
 
   integer :: nx,ny,nxmax,nymax,nzmax,memind(2),m,ix,jy,ixp,jyp
-  integer :: itime,itime1,itime2,level,indexh
+  !integer :: itime,itime1,itime2,level,indexh
+  integer :: itime,itime1,itime2,level,indexh,ip1,ip2,ip3,ip4 
+  integer :: intiy1,intiy2,ipsum,icmv  
   real :: yy1(0:nxmax-1,0:nymax-1,nzmax,2)
   real :: yy2(0:nxmax-1,0:nymax-1,nzmax,2)
   real :: yy3(0:nxmax-1,0:nymax-1,nzmax,2)
-  real :: ddx,ddy,rddx,rddy,dt1,dt2,dt,y1(2),y2(2),y3(2)
-  real :: xt,yt,yint1,yint2,yint3,p1,p2,p3,p4
+  integer iy1(0:nxmax-1,0:nymax-1,2),iy2(0:nxmax-1,0:nymax-1,2)
+  real :: ddx,ddy,rddx,rddy,dt1,dt2,dt,y1(2),y2(2),y3(2),yi1(2),yi2(2)
+  !real :: ddx,ddy,rddx,rddy,dt1,dt2,dt,y1(2),y2(2),y3(2)
+  real :: xt,yt,yint1,yint2,yint3,yint4,p1,p2,p3,p4  
+  !real :: xt,yt,yint1,yint2,yint3,p1,p2,p3,p4
 
 
@@ -127,4 +142,43 @@
          + p3*yy3(ix ,jyp,level,indexh) &
          + p4*yy3(ixp,jyp,level,indexh)
+
+!CPS clouds:
+        ip1=1
+        ip2=1
+        ip3=1
+        ip4=1
+        if (iy1(ix ,jy ,indexh) .eq. icmv) ip1=0
+        if (iy1(ixp,jy ,indexh) .eq. icmv) ip2=0
+        if (iy1(ix ,jyp,indexh) .eq. icmv) ip3=0
+        if (iy1(ixp,jyp,indexh) .eq. icmv) ip4=0
+        ipsum= ip1+ip2+ip3+ip4
+        if (ipsum .eq. 0) then
+          yi1(m)=icmv
+        else
+          yi1(m)=(ip1*p1*iy1(ix ,jy ,indexh)    &
+             + ip2*p2*iy1(ixp,jy ,indexh)       &
+             + ip3*p3*iy1(ix ,jyp,indexh)       &
+             + ip4*p4*iy1(ixp,jyp,indexh))/ipsum
+        endif
+        
+        ip1=1
+        ip2=1
+        ip3=1
+        ip4=1
+        if (iy2(ix ,jy ,indexh) .eq. icmv) ip1=0
+        if (iy2(ixp,jy ,indexh) .eq. icmv) ip2=0
+        if (iy2(ix ,jyp,indexh) .eq. icmv) ip3=0
+        if (iy2(ixp,jyp,indexh) .eq. icmv) ip4=0
+        ipsum= ip1+ip2+ip3+ip4
+        if (ipsum .eq. 0) then
+          yi2(m)=icmv
+        else
+          yi2(m)=(ip1*p1*iy2(ix ,jy ,indexh)  &
+             + ip2*p2*iy2(ixp,jy ,indexh)     &
+             + ip3*p3*iy2(ix ,jyp,indexh)     &
+             + ip4*p4*iy2(ixp,jyp,indexh))/ipsum
+        endif
+!CPS end clouds
+
   end do
 
@@ -134,4 +188,11 @@
   !************************************
 
+      if (itime .lt. itime1) then
+        print*,'interpol_rain.f90'
+        print*,itime,itime1,itime2
+        stop 'ITIME PROBLEM'
+      endif
+
+
   dt1=real(itime-itime1)
   dt2=real(itime2-itime)
@@ -143,3 +204,20 @@
 
 
+!PS clouds:
+      intiy1=(yi1(1)*dt2 + yi1(2)*dt1)/dt
+      if (yi1(1) .eq. float(icmv)) intiy1=yi1(2) 
+      if (yi1(2) .eq. float(icmv)) intiy1=yi1(1) 
+
+      intiy2=(yi2(1)*dt2 + yi2(2)*dt1)/dt
+      if (yi2(1) .eq. float(icmv)) intiy2=yi2(2)  
+      if (yi2(2) .eq. float(icmv)) intiy2=yi2(1) 
+      
+      if (intiy1 .ne. icmv .and. intiy2 .ne. icmv) then
+        intiy2 = intiy1 + intiy2 ! convert cloud thickness to cloud top
+      else
+        intiy1=icmv
+        intiy2=icmv
+      endif
+!PS end clouds
+
 end subroutine interpol_rain
Index: branches/FLEXPART_9.1.3/src/logfile
===================================================================
--- branches/FLEXPART_9.1.3/src/logfile	(revision 14)
+++ branches/FLEXPART_9.1.3/src/logfile	(revision 14)
@@ -0,0 +1,10 @@
+FLEXPART 9.1 from 
+svn/FlexPart90/branches/flexpart91_hasod/src 
+Assume that HS started from the trunk version (9.02)
+
+
+FLEXPART 9.1.1 (build 1) add changes in SE's version (trunk)
+
+FLEXPART 9.1.2 add NIK's additions
+
+FLEXPART 9.1.3 add PS  
Index: branches/FLEXPART_9.1.3/src/makefile
===================================================================
--- branches/FLEXPART_9.1.3/src/makefile	(revision 14)
+++ branches/FLEXPART_9.1.3/src/makefile	(revision 14)
@@ -0,0 +1,104 @@
+SHELL = /bin/bash
+MAIN = FLEXPART_GFORTRAN
+#
+
+FC       = gfortran
+#INCPATH  = /usr/local/ecmwf_tools/reloc/include
+#LIBPATH1 = /usr/local/ecmwf_tools/reloc/lib
+#LIBPATH2 = /usr/local/lib
+#FFLAGS   = -O3 -g -fbounds-check -m64 -mcmodel=medium -fconvert=little-endian -frecord-marker=4 -I$(INCPATH)
+FFLAGS   = -O3 -m64 -mcmodel=medium -fconvert=little-endian -frecord-marker=4 -I$(INCPATH)
+#LDFLAGS  = $(FFLAGS) -L$(LIBPATH2) -L$(LIBPATH1) -lgrib_api_f90 -lgrib_api -lm -lopenjpeg
+
+# options for nordre
+INCPATH  = /xnilu_wrk/flex_wrk/bin64/grib_api/include
+LIBPATH1 = /xnilu_wrk/flex_wrk/bin64/grib_api/lib
+LIBPATH2 =   /usr/lib/x86_64-linux-gnu/
+#FFLAGS   =   -O2 -m64 -mcmodel=medium -fconvert=little-endian -frecord-marker=4 -I$(INCPATH)
+LDFLAGS  = $(FFLAGS) -L$(LIBPATH2) -L$(LIBPATH1) -lgrib_api_f90 -lgrib_api -lm -ljasper
+
+#options for Lion
+libs_dir=/Users/ignacio_in_EBCRPA/flexpart/libs/
+INCPATH  = $(libs_dir)/grib_api-1.9.9_dir/include
+LIBPATH1 = $(libs_dir)/grib_api-1.9.9_dir/lib
+LIBPATH2 = $(libs_dir)/jasper_dir/lib
+
+
+
+MODOBJS = \
+par_mod.o               com_mod.o \
+conv_mod.o              hanna_mod.o \
+interpol_mod.o          cmapf_mod.o \
+unc_mod.o               oh_mod.o \
+xmass_mod.o             flux_mod.o \
+point_mod.o             outg_mod.o
+
+OBJECTS = \
+writeheader.o           assignland.o\
+calcpar.o               part0.o \
+caldate.o               partdep.o \
+coordtrafo.o            psih.o \
+raerod.o \
+drydepokernel.o         random.o \
+readavailable.o \
+ew.o                    readcommand.o \
+advance.o               readdepo.o \
+releaseparticles.o      psim.o     \
+FLEXPART.o              readlanduse.o \
+getfields.o             init_domainfill.o\
+interpol_wind.o         readoutgrid.o \
+interpol_all.o          readpaths.o \
+getrb.o                 readreceptors.o \
+getrc.o                 readreleases.o \
+getvdep.o               readspecies.o \
+interpol_misslev.o      readwind.o \
+conccalc.o              richardson.o \
+concoutput.o            scalev.o \
+pbl_profile.o           readOHfield.o\
+juldate.o               timemanager.o \
+interpol_vdep.o         interpol_rain.o \
+verttransform.o         partoutput.o \
+hanna.o                 wetdepokernel.o \
+mean.o                  wetdepo.o \
+hanna_short.o           windalign.o \
+obukhov.o               gridcheck.o \
+hanna1.o                initialize.o \
+                        gridcheck_nests.o \
+readwind_nests.o        calcpar_nests.o \
+verttransform_nests.o   interpol_all_nests.o \
+interpol_wind_nests.o   interpol_misslev_nests.o \
+interpol_vdep_nests.o   interpol_rain_nests.o \
+getvdep_nests.o \
+readageclasses.o        readpartpositions.o \
+calcfluxes.o            fluxoutput.o \
+qvsat.o                 skplin.o \
+convmix.o               calcmatrix.o \
+convect43c.o               redist.o \
+sort2.o                 distance.o \
+centerofmass.o          plumetraj.o \
+openouttraj.o           calcpv.o \
+calcpv_nests.o          distance2.o \
+clustering.o            interpol_wind_short.o \
+interpol_wind_short_nests.o shift_field_0.o \
+shift_field.o           outgrid_init.o \
+openreceptors.o         boundcond_domainfill.o\
+partoutput_short.o      readoutgrid_nest.o \
+outgrid_init_nest.o     writeheader_nest.o \
+concoutput_nest.o       wetdepokernel_nest.o \
+drydepokernel_nest.o    zenithangle.o \
+ohreaction.o            getvdep_nests.o \
+initial_cond_calc.o     initial_cond_output.o \
+dynamic_viscosity.o     get_settling.o
+
+
+$(MAIN): $(MODOBJS) $(OBJECTS)
+	$(FC) *.o -o $(MAIN) $(LDFLAGS)
+
+$(OBJECTS): $(MODOBJS)
+
+%.o: %.f90
+	$(FC) -c $(FFLAGS) $<
+
+clean:
+	rm *.o *.mod
+
Index: branches/FLEXPART_9.1.3/src/makefile.ecmwf_gfortran
===================================================================
--- trunk/src/makefile.ecmwf_gfortran	(revision 14)
+++ branches/FLEXPART_9.1.3/src/makefile.ecmwf_gfortran	(revision 14)
@@ -9,5 +9,4 @@
 LIBPATH2 =   /usr/lib/x86_64-linux-gnu/
 #LIBPATH2 =   /flex_wrk/flexpart/lib64/gfortran/lib/
-#FFLAGS   =   -O3 -m64 -mcmodel=medium -fconvert=little-endian -frecord-marker=4 -I$(INCPATH)
 FFLAGS   =   -O2 -m64 -mcmodel=medium -fconvert=little-endian -frecord-marker=4 -I$(INCPATH)
 #FFLAGS   =   -fbounds-check -m64 -mcmodel=medium -fconvert=little-endian -frecord-marker=4 -I$(INCPATH)
Index: branches/FLEXPART_9.1.3/src/par_mod.f90
===================================================================
--- trunk/src/par_mod.f90	(revision 14)
+++ branches/FLEXPART_9.1.3/src/par_mod.f90	(revision 14)
@@ -28,5 +28,5 @@
 !        1997                                                                  *
 !                                                                              *
-!        Last update 10 August 2000                                            *
+!        Last update 15 August 2013 IP                                         *
 !                                                                              *
 !*******************************************************************************
@@ -122,7 +122,8 @@
 
   integer,parameter :: nxmax=361,nymax=181,nuvzmax=92,nwzmax=92,nzmax=92
-  !integer,parameter :: nxmax=361,nymax=181,nuvzmax=61,nwzmax=61,nzmax=61
+  !integer,parameter :: nxmax=361,nymax=181,nuvzmax=26,nwzmax=26,nzmax=26
   !integer,parameter :: nxmax=721,nymax=361,nuvzmax=64,nwzmax=64,nzmax=64
-  integer,parameter :: nxshift=359  ! for ECMWF
+  !integer,parameter :: nxmax=1201,nymax=235,nuvzmax=58,nwzmax=58,nzmax=58
+  integer,parameter :: nxshift=359 ! for ECMWF
   !integer,parameter :: nxshift=0     ! for GFS
 
@@ -150,6 +151,6 @@
   !*********************************************
 
-  integer,parameter :: maxnests=0, nxmaxn=0, nymaxn=0
-  !integer,parameter :: maxnests=1,nxmaxn=251,nymaxn=151
+  !integer,parameter :: maxnests=0, nxmaxn=0, nymaxn=0
+  integer,parameter :: maxnests=1,nxmaxn=251,nymaxn=151
 
   ! maxnests                maximum number of nested grids
@@ -194,6 +195,6 @@
   !**************************************************
 
-  integer,parameter :: maxpart=2000000
-  integer,parameter :: maxspec=4
+  integer,parameter :: maxpart=150000
+  integer,parameter :: maxspec=1
 
 
@@ -258,3 +259,10 @@
   integer,parameter :: unitboundcond=89
 
+!******************************************************
+! integer code for missing values, used in wet scavenging (PS, 2012)
+!******************************************************
+
+      integer icmv
+      parameter(icmv=-9999)
+
 end module par_mod
Index: branches/FLEXPART_9.1.3/src/readavailable.f90
===================================================================
--- trunk/src/readavailable.f90	(revision 14)
+++ branches/FLEXPART_9.1.3/src/readavailable.f90	(revision 14)
@@ -123,4 +123,6 @@
 
   do k=1,numbnests
+  print*,length(numpath+2*(k-1)+1),length(numpath+2*(k-1)+2),length(4),length(3)
+  print*,path(numpath+2*(k-1)+2)(1:length(numpath+2*(k-1)+2))
     open(unitavailab,file=path(numpath+2*(k-1)+2) &
          (1:length(numpath+2*(k-1)+2)),status='old',err=998)
@@ -275,5 +277,5 @@
   return
 
-998   write(*,*) ' #### FLEXPART MODEL ERROR! FILE   #### '
+998   write(*,*) ' #### FLEXPART MODEL ERROR! AVAILABLE FILE   #### '
   write(*,'(a)') '     '//path(numpath+2*(k-1)+2) &
        (1:length(numpath+2*(k-1)+2))
@@ -281,5 +283,5 @@
   stop
 
-999   write(*,*) ' #### FLEXPART MODEL ERROR! FILE #### '
+999   write(*,*) ' #### FLEXPART MODEL ERROR! AVAILABLE IILE #### '
   write(*,'(a)') '     '//path(4)(1:length(4))
   write(*,*) ' #### CANNOT BE OPENED           #### '
